local addonName, addon = ...;
local RandomMountOptionFrame = CreateFrame('Frame', 'RandomMountOptionFrame');

local events = {};

local L = setmetatable({}, {
    __index = function(table, key)
        return key;
    end,
});

addon.L = L;

local rmDropDownOptions = {
    { VALUE = 1,
      TEXT = L['beginner'], },
    { VALUE = 2,
      TEXT = L['amateur'], },
    { VALUE = 3,
      TEXT = L['professional'], },
};

local sizeRandomMountButtonDropDownOptions = {
    { VALUE = 16,
      TEXT = L['very small'], },
    { VALUE = 32,
      TEXT = L['small'], },
    { VALUE = 64,
      TEXT = L['normal'], },
    { VALUE = 128,
      TEXT = L['big'], },
};

function RandomMountOptionFrame:registerEvents(events)
    for key, value in pairs(events) do
        RandomMountOptionFrame:RegisterEvent(key);
    end

    local function eventHandler (self, event, ...)
        events[event](self, ...);
    end

    RandomMountOptionFrame:SetScript('OnEvent', eventHandler);
end

local function RandomMountButtonUpdate()
    _G['RandomMountButton']:SetShown(addon.settings['showRandomMountButton']);
    _G['RandomMountButton']:SetMovable(not addon.settings['lockRandomMountButton']);
    _G['RandomMountButton']:SetSize(addon.settings['randomMountButtonSizeDropdown'],
            addon.settings['randomMountButtonSizeDropdown']);
end

local function DebugButtonsUpdate()
    _G['DebugButtonOptions']:SetShown(addon.settings['enableDebug']);
    _G['DebugButtonOptions']:SetSize(32, 32);
end

local function createOptions()

    local rmSettingsFrame = CreateFrame('Frame', 'rmSettingsFrame', UIParent);
    rmSettingsFrame.name = 'RandomMounter';

	addon.createCheckBox('disableRandomMounter', L['disable'], rmSettingsFrame, "TOPLEFT", 'TOPLEFT', 15, -15)

    addon.createDropDown('rmModeDropdown', rmSettingsFrame, "TOPLEFT", 'TOPLEFT', 0, -35,
            rmDropDownOptions)

    addon.createCheckBox('grmlWTHCheckButton', 'grmlWTH', rmSettingsFrame, "TOPLEFT", 'TOPLEFT', 15, -60)

    addon.createCheckBox('flyingMountsAsGroundCheckButton', L['consider flying mounts as ground mounts'], rmSettingsFrame,
            "TOPLEFT", 'TOPLEFT', 15, -80)

    addon.createCheckBox('useCustomFavListButton', L['use custom favorite list'], rmSettingsFrame, "TOPLEFT", 'TOPLEFT', 15
    , -100)
    addon.createDropDown('randomMountButtonSizeDropdown', rmSettingsFrame, "TOPLEFT", 'TOPLEFT', 330, -35,
            sizeRandomMountButtonDropDownOptions, RandomMountButtonUpdate)

    addon.createCheckBox('lockRandomMountButton', L['lock randommount button'], rmSettingsFrame, "TOPLEFT", 'TOPLEFT', 345, -60,
            RandomMountButtonUpdate)
    addon.createCheckBox('showRandomMountButton', L['show randommount button'], rmSettingsFrame, "TOPLEFT", 'TOPLEFT', 345, -80,
            RandomMountButtonUpdate)

    addon.createCheckBox('enableDebug', L['enable debug mode'], rmSettingsFrame, "TOPLEFT", 'TOPLEFT', 180, -35,
            DebugButtonsUpdate)

    InterfaceOptions_AddCategory(rmSettingsFrame);
end

function events:PLAYER_LOGIN ()
    createOptions();
end

RandomMountOptionFrame:registerEvents(events);